#include "editspecialoptions.h"
//
editSpecialOptions::editSpecialOptions( QWidget * parent, QString optionName, QString * optionString, bool * ok) : QDialog(parent)
{
	setupUi(this);
	globalOk = ok;
	*globalOk = true;
	headerLabel->setText(optionName);
	globalOptionString = optionString;
	fillTable();
}

void editSpecialOptions::fillTable(){
QString tempString = *globalOptionString;
QStringList headerString;
QString entry;
int end;
int index = 0;

	headerString << tr("Values");
	valueTable->clear();
	valueTable->setHorizontalHeaderLabels(headerString);
	while (tempString != ""){
		if (tempString.contains(" ")){
			end = tempString.indexOf(" ");
		} else {
			end = tempString.length();
		}
		entry = tempString.left(end);
		tempString = tempString.mid(end + 1);
		valueTable->insertRow(index);
		valueTable->setItem(index,0,new QTableWidgetItem(entry));
		valueTable->setColumnWidth(0,560);
		index++;
	}
}

void editSpecialOptions::slot_addButtonClicked(){
bool found = false;

	for (int i = 0; i < valueTable->rowCount(); i++){
		if (valueTable->item(i,0)->text() == valueLineEdit->text()) found = true;
	}
	if (!found){
		valueTable->insertRow(valueTable->rowCount());
		valueTable->setItem(valueTable->rowCount()-1,0,new QTableWidgetItem(valueLineEdit->text()));
		*globalOk = false;
	}
}

void editSpecialOptions::slot_delButtonClicked(){
	if (valueLineEdit->text() != ""){
		if ((valueTable->rowCount() != 0) && (valueTable->currentItem()->text() == valueLineEdit->text())){
			valueTable->removeRow(valueTable->currentRow());
			*globalOk = false;
		}
	}
}

void editSpecialOptions::slot_submitButtonClicked(){
QString tempString;

	for (int i = 0; i < valueTable->rowCount(); i++){
		tempString = tempString + valueTable->item(i,0)->text() + " ";
	}
	*globalOptionString = tempString.trimmed();
	this->done(true);
	
}

void editSpecialOptions::slot_discardButtonClicked(){
	*globalOk = true;
	this->done(false);
}

void editSpecialOptions::slot_tableClicked(){
	valueLineEdit->setText(valueTable->item(valueTable->currentRow(),0)->text());
}

void editSpecialOptions::slot_clearButtonClicked(){
	if (QMessageBox::question(this,tr("Clear List"),tr("Do you really want to clear the list?"),QMessageBox::Yes,QMessageBox::No) == QMessageBox::Yes){
		int count = valueTable->rowCount();
		for (int row=0;row < count; row++) valueTable->removeRow(0);
	}
	*globalOk = false;
}
//
